//These routines were part of the Sparkfun web server demo for
//ESP8266 Thing, DEV BOARD version (Sparkfun part WRL13711)

//Some modifications may have been made by TKB, 1/17

void connectWiFi()
{
  byte ledStatus = LOW;
  Serial.println();
  Serial.println("Connecting to: " + String(WiFiSSID));
  // Set WiFi mode to station (as opposed to AP or AP_STA)
//ADDED TO DEMO BY TKB... 2 of 2 to set static IP address
  WiFi.config(ip, gateway, subnet);

  WiFi.mode(WIFI_STA);

  // WiFI.begin([ssid], [passkey]) initiates a WiFI connection
  // to the stated [ssid], using the [passkey] as a WPA, WPA2,
  // or WEP passphrase.
  WiFi.begin(WiFiSSID, WiFiPSK);

  // Use the WiFi.status() function to check if the ESP8266
  // is connected to a WiFi network.
  while (WiFi.status() != WL_CONNECTED)
  {
    // Blink the LED
    digitalWrite(LED_PIN, ledStatus); // Write LED high/low
    ledStatus = (ledStatus == HIGH) ? LOW : HIGH;

    // Delays allow the ESP8266 to perform critical tasks
    // defined outside of the sketch. These tasks include
    // setting up, and maintaining, a WiFi connection.
    delay(100);
    // Potentially infinite loops are generally dangerous.
    // Add delays -- allowing the processor to perform other
    // tasks -- wherever possible.
  }
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}//end of void connectWiFi()

void setupMDNS()
{
  // Call MDNS.begin(<domain>) to set up mDNS to point to
  // "<domain>.local"
  if (!MDNS.begin("thing")) 
  {
    Serial.println("Error setting up MDNS responder!");
    while(1) { 
      delay(1000);
    }
  }
  Serial.println("mDNS responder started");

}//end of void setupMDNS()

void initHardware()
{
  //With additions by TKB
  pinMode(DIGITAL_PIN, INPUT_PULLUP);
  pinMode(LED_PIN, OUTPUT);
//NEXT would be REMMED OUT IN 3-2 see decl of Pin_Show...
  pinMode(Pin_ShowAnemomInputStatus, OUTPUT);//For FW002 wants
  pinMode(pinLight, OUTPUT);//This part of tweaks to make this vers 3-2
  pinMode(Pin_AnemomInput, INPUT_PULLUP);//For FW002 wants
  pinMode(Pin_ShowPulse1InputStatus, OUTPUT);//For FW002 wants
  pinMode(Pin_Pulse1Input, INPUT_PULLUP);//For FW002 wants
//Scraps of curtain control version
//pinMode(pinCurt0, OUTPUT);
//  pinMode(pinCurt1, OUTPUT);
  
  digitalWrite(LED_PIN, HIGH);
  // Don't need to set ANALOG_PIN as input, 
  // that's its default state.
}//initHardware()


