#include <ESP8266mDNS.h>

#define sPrgm "ar794"
#define sVersID "24 Mar 19 12:50"

//Note: This uses support .inos...
/*FINISH figuring out...
 * 
 * LED on 15 flashes until WiFi connection good.
 


 */

//Most things that might be changed, are changed by alerting the values assigned
//  with the #defines at the top of this .ino file.

//N.B: The webpage that talks about "this" is talking about a family of webservers.
//While they all have much in common, there are ways that individual instances
//  could have been tweaked. Don't take the diagrams on the webpage, etc, to
//  be absolutely set in stone.

//Note that there are at least 3 subordinate .ino files which support this one.
//  For1WireTtureSensors
//  FromSparkfun
//  TKB_Bits_FWW

//That said... onward! It isn't as bad as you may by now be fearing!

//================================================
//Set aspects of the stepper motor "pulse"...
//N.B. (If using the "servo pulse" option): IT IS IN NATURE OF SERVOS that 
//   they go to a "start" posn during power on init.
//   Build system around that fact. (Mount servo, choose Rest and To
//   accordingly.)

#define kbStepRest 40//Where stepper should be between "pulses"
#define kbStepTo 0//Where stepper goes for kiStepDur, when doing pulse
#define kiStepDur 800//Time in milliseconds it should go to "To" before
  //returning to "Rest"

//Enter here a short string of text for
//sTabText (below). It will determine the label
//of the page's tab when it is displayed in most browsers.
//It should probably be specific to the hardware in question;
//   there are other places to identify the software
#define sTabText "ICH07k"

//Sundry things to be set for local wants...
//(Main documentation follows)

//************
//REMEMBER TO REMOVE SSID/ PW when doing copy for publication!
//////////////////////

//WiFi SSID and the password for that network...
#define sSSID "SSID_HERE"
#define sWiFiPSK "WIFI-PW_HERE"

//Next sets port page is served on. Use 80, if in doubt
#define iServeOn 1209

//Note: The original demo didn't force the device to
//  a hardcode static IP. (It relied on either
//  DHCP or on the router assigning the local
//  IP address based on the device's MAC.)
//Next four set the local IP address of device.
//For 192.168.0.55, set a, b, c and d to
//    those values, that order
#define iLIPAa 192
#define iLIPAb 168
#define iLIPAc 0
#define iLIPAd 203

//Set next four to tell device where the gateway is,
//     if it is to "talk" to outside world.
//192,168,0,1, if not connecting to outside world, but
//     lock that door at your router, too. Not sure
//     how to lock at Arduserver. ("GW" for "gateway".)
#define iGWa 192
#define iGWb 168
#define iGWc 0
#define iGWd 1

//Set next for to tell device what subnet mask to use.
//If in doubt, make them 255,255,255,0
//("SNM" for "subnet mask".)
#define iSNMa 255
#define iSNMb 255 
#define iSNMc 255 
#define iSNMd 0


//General documetation...
//Derives from...
//ESP8266_web_server_for_fw002_Mk3-2
//"ver 3-2... NOT for publication".. 
//(as it was 23 Mar 19)

//See....
//http://sheepdogguides.com/elec/misc/esp8266/Esp8266-Arduserver.htm
//
//... for more information.

#include <ESP8266WiFi.h>
#include <OneWire.h>
#include <Servo.h>//(Ordinary one.. only needed for "pulse" command/ SendStep stuff.)
//See http://sheepdogguides.com/arduino/aht3servo.htm for stuff on servos

//Mk2 started 4 Jan 17.. Mk2 had "proper" "intelligent" "non-blocking" delay-for-Ds18B20 convert
//     Mk2 also had pulse counter.
//Mk2 was crude... but even so, it worked! Reported tture from a DS18B20,
//and counted anemometer pulses, and provided a FW002-friendly
//web page.

//Mk2 put the reading of the DS18B20 on a much more sensible
//footing, using ideas in sg/arduino/DS18B20-HowTo.htm

//Mk1 started 30 Dec 16, 15:35... deathly ill with aweful cold.
//First "big" ESP8266 prgm... but still mostly the Sparkfun WebServer example.

//Web-server elements derived from Sparkfun example...
//https://learn.sparkfun.com/tutorials/esp8266-thing-development-board-hookup-guide/example-sketch-web-server


//////////////////////
// WiFi Definitions //
//////////////////////
//Tweak next two for your WiFi environment, and take
//  care not to tell people who shouldn't know
//  what settings you've supplied to the Thing...
const char WiFiSSID[]=sSSID;
const char WiFiPSK[] =sWiFiPSK;

WiFiServer server(iServeOn);

//THREE LINES ADDED BY TKB TO BASIC DEMO.... Block 1 of 2 to set static IP address
IPAddress ip(iLIPAa,iLIPAb,iLIPAc,iLIPAd);
IPAddress gateway(iGWa,iGWb,iGWc,iGWd);
IPAddress subnet(iSNMa,iSNMb,iSNMc,iSNMd);

//See discussion below for what boDriveStepperNotLED is about...
//Note that the commands accepted by the device are affected by the state of boDriveStepperNotLED...
//   The "/pulse" command is added to what is acceptable.
#define boDriveStepperNotLED true

/////////////////////
// Pin Definitions //
/////////////////////

//Scrap of something not properly written up... Ignore references
//  to the "curtain control"/ "burgler fooling" version.
//For 3-2 tweak, curtains control...
//14 and 2 WERE second counter, in 3-1.
//ARE used for SPI... or is it I2C... if you WANT that, which
//  I am happy to sacrifice for 3-2.

//const int pinCurt0=14;
//const int pinCurt1=2;

//(end of "Scrap of something...)


const int pinLight=5;//The line of the Sparkfun Thing with on-board LED used
// to drive the signal to the light that will go on/off to make house
// look occupied, because it might as well be this line as any other, and
// using this line gives visual indication that command arrived, even when
// circuit to/ bulb in light not working.

const int LED_PIN=15;//NOTE: DUE TO CODE IN "FromSparkfun, until the WiFi connection is
  //established, or while it is being re-established, this pin is used as an
  //output. (If you put an LED on it, if the LED is flashing (about 0.1 sedond on/
  //0.1 second off), then the WiFi connection has not (yet) been successful.

  //The "Arduserver" software ALSO uses this output, to drive an LED (or other),
  //as directed by /led/0 and /led/1 commands.

  //BEWARE: Whatever purpose you have in mind for the result of the /led/0
  //and led/1 commands, it MUST BE TOLERANT of this other operation of
  //the output, unless you take that out of the FromSparkfun code.
  
  //Put LED and resistor from this pin to 3v3,
  //if one not already provided on board. (Sparkfun ESP8266 has LED+resistor on line 5.
  //"ordinary Arduinos usually have one on line 13.)
  //Although this is called LED_PIN, you don't HAVE to use it to drive an LED,
  //of course. The "led/0" and "led/1" commands will set the state of whatever
  //pin "LED_PIN" has been assigned to. Not that the "0" command would turn an
  //LED connected to 3v3 OFF, by making the output **HIGH**. A little counter
  //intuitive. It is easy to think that "LED/0" would mean make that pin LOW...
  //but it would be wrong! (Whys and wherefors discussed elsewhere!)
  
const int ANALOG_PIN=A0; // The only analog pin on the Thing
//N.B.: IT SHOULD NOT BE SUBJECTED TO MORE THAN 1v!
//(Or maybe all voltages from 1v to 3v3 volts give the same reading... but I
//   don't know if you can get away with the higher voltages. I do know
//   AT LEAST you won't get a different reading than 1v returned.
//For Arduserver app, a light sensor can be wired to ANALOG_PIN, and it can be
//   arranged so that the LED the user can turn on and off provides most of the light
//   illuminating the light sensor. This lets the person accessing the server
//   see what state the LED is in.

const int DIGITAL_PIN=12; // Pin to be read as digital input. Had little luck
  //trying to use pin 15 or 16 for this. Probably something "silly".

//BEGIN TKB BLOCK relating to creating something for FW002 to "watch"...
//The Webserver demo software from Sparkfun uses the built in LED to demo
//  setting/ clearing an output. It refers to the pin as LED_PIN

//Thoroughout, where you see "Anemometer", you can consider that to say
//  "Source of aperiodic square wave. The "anemometer" pins and features can
//  count changes in resistance arising from any external circuit. I'm not
//  sure wheter it counts switch closures or openings. There's an input. It
//  has a 10k pull-up on it. (The pull-up is inside the ESP8266).
//I don't believe that "just any pin" will do for this function.
//The number of edges is reported by the first hhhh datum.
//There's a second pin associated with the Anemometer: Pin_ShowAnemomInputStatu
//  That is an output. It reflects the state of the "anemometer" input.
//Put an LED (with a resistor) on the assigned GPIO pin if you want an almost
//  direct indication of the pin's state. (You can't put it directly on the
//  input, because that is resistance driven, not voltage.)
const byte Pin_AnemomInput=13;//The anemometer should pull this line LOW when it has
  //rotated to a certain postion (or positions) in its normal rotation. The pin is
  //configured INPUT_PULLUP, so you don't need to put a pull-up on the line. Had little luck
  //trying to use pin 15 or 16 for this. Probably something "silly".

/*THIS DECLARATION would be REMMED OUT to create vers to allow this pin to control fool-the-burglar light.*/
//This signal can be routed elsewhere... perhaps swap assignments with the pin
//  normally used for LED_PIN?... if you want to use the ON-BOARD LED to give you
//  information about something different.
const byte Pin_ShowAnemomInputStatus=5;//Put LED and resistor from this pin to Gnd.
  //If you assign this to pin 5, the on-board LED will display the state of the 
  //   anemometer input. *IF YOU DO CHANGE THE ASSIGNMENT* be sure to ALSO
  //   change the assignment of what WAS on the pin you've moved this signal to.
  //   (Sparkfun ESP8266 has LED+resistor on line 5."ordinary" Arduinos usually
  //   have one on line 13.
// end of "rem out to enable burglar light"

/*Remmed out, for ver 3-2, to make 14 and 2 avail for controlling curtains.
 * "Costs" second counter.
//Here begins the addition of a second pulse counter to the webserver.
//"Pulse0" was badly named... "Anemom".
//At one point, I was using pins 14 and 2 for Pin_Pulse1Input and Pin_ShowPulse1InputStatus
//   respectively. Bear in mind that those pins are the usual pins to use for I2C
//   SCL and SDA, so you have to make a choice... Pulse1, or I2C devices... in a simple
//   world. Of course, other compromises can be made and you can have two pulse
//   counters AND I2C, if, say, you sacrifice the LEDs which indicate the states on
//   the lines the pulse counters watch.
*/

//Pin_Pulse1Input and Pin_ShowPulse1InputStatus were, originally, just associated withe a second
//  pulse counting regime. ("Pulse0" being the one nominally dedicated to an anemometer.)
//And Pin_Pulse1Input still CAN be used exactly as before.
//However, if you set "boDriveStepperNotLED" true, then the pin assigned to
//   "Pin_ShowPulse1InputStatus" (which normally is just a quick way to "watch" what is happening
//   on Pin_Pulse1Input)becomes the output for the "/pulse" command.
//This "becomes the output for..." happens if we enable the line below (just under
//   the one saying Pin_ShowPulse1InputStatus) that says "...ServoPin=Pin_ShowPulse1InputStatus;"
//Note: It "doesn't matter" whether you have an LED or a stepper motor connected
//   to the pin assigned to Pin_ShowPulse1InputStatus. Of course, things won't "work"
//   when you have a mis-match... but no harm will be done to the ESP8266 or the external
//   components.

//Note that the commands accepted by the device are affected by the state of boDriveStepperNotLED.
//   The "/pulse" command is added to what is acceptable. And also, the associated on-screen
//   prompts change.

const byte Pin_Pulse1Input=14;//The external circuit should pull this line LOW when it has
  //rotated to a certain postion (or positions) in its normal rotation. The pin is
  //configured INPUT_PULLUP, so you don't need to put a pull-up on the line.
  
const byte Pin_ShowPulse1InputStatus=2;//Put LED and resistor from this pin to 3v3,
  //if one not already provided on board. (Sparkfun ESP8266 has LED+resistor on line 5.
  //"ordinary" Arduinos usually have one on line 13.)
  //I had some tedious issues with LEDs being on when they should be off, and vice versa
  //... but they were consistent. I also had a hassle in that if I connected an LED from pin
  //    15, through a 1k resistor, to 3V3, I could no longer do uploads. But my pin 15
  //    was being odd in other ways, too. And pin 16. Probably something "silly".

//Next few for stepper/ pulse handling. 

//https://circuits4you.com/2019/01/12/esp8266-servo-motor-control/ helped me get this far.

//Chose which pin to re-purpose. Chose carefully.

//In the rest of the program, only one of the two (ServoPin and Pin_ShowPulse1InputState)
//  should be active during any "run" of the program. This is controlled by the
//  state of boDriveStepperNotLED
const byte ServoPin=Pin_ShowPulse1InputStatus;

//#define ServoPin 14   //D5 is GPIO14" << Didn't work
//#define ServoPin D5 //Wouldn't compile
//Also did not work: 14, A0,
//#define ServoPin 2 //Worked!
//Also worked: 5,13 //(5 has on-board LED on it.
//           13 needed for SPI if you want to use that.

Servo MyServo;  // create servo object to control a servo

//end of block of things relating to stepper/ pulse feature

/*END... block remmed out to make 14 and 2 avail for curtain controls*/

long int liLoopCycleCount =0;
int iTmp;
byte bInputLine=0;

//END TKB BLOCK relating to creating something for FW002 to "watch"...

//THIS BLOCK ADDED, TKB, 1 Jan 17 for read-DS18B20 tture sensor wants...
//See a different read-DS18B20 block for source of ideas uses.

//For this code to compile, you need to add the "OneWire" library to your Arduino IDE.
//(And, no, the "Wire" library is NOT what I am talking about!)

unsigned long ulMillisAtPrevTenthsBump;
unsigned long ulTmp;
long int liTenthsPassed=0;
long int liTenthsPassedPrev=0;
long int liTenthsPassedWhenConvertRequested;
 
//End block added for read-DS18B20

//--------
//THIS BLOCK ADDED, TKB, 1 Jan 17 for read-DS18B20 tture sensor wants... based on material at...
//http://www.elec-cafe.com/temperature-sensor-on-the-web-with-esp8266-and-ds18b20/

//ds0 and ds2 are ways to access 1-Wire chips on the pins spec'd in the following
//N.B.... in Mk2 and earlier of this software, there was just one ds channel, called "ds".
//  many other old variables have gained a "0" and a coresponding "1" twin.
OneWire  ds0(4);  // on pin 4 (a 4.7K resistor pull up to the system's 3v3 is necessary, too)
OneWire  ds1(0);  // on pin 0 (a 4.7K resistor pull up to the system's 3v3 is necessary, too)
//(Pin 16 didn't work as a pin for using 1-Wire with for some reason. 7 Jan 17)

byte i;
byte present = 0;
byte data[12];

byte type_s0, type_s1;
byte addr0[8], addr1[8];
float celsius0, celsius1,
   fahrenheit0, fahrenheit1,
   celsiusX10_0, celsiusX10_1;

//...and to "stuff" into web-page...
//(there must be a better way!... (But I wanted a fixed format, e.g.
//"+025" for 2.5 deg C, or "-128" for -12.8 deg C.)

char cSTture0 ='+';
char cTturDC0Huns ='0';//Temperature, in Celcuis DECIdecgrees... i.e. 12.4 degC is 124 deg
char cTturDC0Tens ='0';
char cTturDC0Units ='0';

char cSTture1 ='+';
char cTturDC1Huns ='0';//Temperature, in Celcuis DECIdecgrees... i.e. 12.4 degC is 124 deg
char cTturDC1Tens ='0';
char cTturDC1Units ='0';

//END BLOCK ADDED BY TKB for read-DS18B20
//-------------------

//THIS BLOCK ADDED, TKB, 30 Dec 16 for FW002 wants...
//... and more added for secong pulse counter, here and elsewhere, 10 Jan 17
char sTKB4Char0[4];
boolean boIpFrmAnemomHigh =false;
boolean boIpFrmAnemomHighPrev =false;
long int liPulsesAnemom = 0000;

boolean boIpFrmPulse1High =false;
boolean boIpFrmPulse1HighPrev =false;
long int liPulse1 = 0000;

long int liTmp;

//... and to "stuff" reading into web-page... there must be a
//better way! (But I wanted always 4 digits, so "0002" when
//only two pulses counted so far on anemometer input.)
char cAnemomThous ='0';
char cAnemomHuns ='0';
char cAnemomTens ='0';
char cAnemomUnits ='0';

char cPulse1Thous ='0';//"Pulse ONE", not "Pulse 'ell' "
char cPulse1Huns ='0';
char cPulse1Tens ='0';
char cPulse1Units ='0';

//END BLOCK ADDED BY TKB for FW002 wants...

//"Prototypes"... helps compiler find things defined on tabs. See....
//http://jgarduino.blogspot.com/2013/04/arduino-ide-multiple-tabs-and-was-not.html
//Beware... if you change the SR, e.g. add params to the call, it may be AGES
//   before system complains. If you get a "too many arguments, check whether your
//   prototype got out of step with the SR.
void LED_On_ForFWW();//prototype of sr defined on a tab
void LED_Off_ForFWW();// (prevents "not declared in this scope" "errors")
void OneWireAskThatReadingBeStarted(byte bWhich);// ditto
void OneWireFetchReadingThatWasTaken(byte bWhich);// ditto
void OneWireProcessCelsiusToOther(byte bWhich);// ditto
void OneWireCheckChipAndInitVars(byte bWhich);// ditto
//Tried to do...
//void SendStepperPulse(byte bStepToL; int iStepDurL);
//.. but couldn't get it right. So using globals... bad, but works!
//Globals are bStepTo, iStepDur, bStepRest
void SendStepperToRest(byte bStepRestL);
void SendStepperPulse(byte bStepToL, int iStepDurL, byte bStepRestL);


//More prototypes. These routines on "From Sparkfun" tab...
void connectWiFi();
void setupMDNS();
void initHardware();//Is in FromSparkfun- things done in their demo, mostly

//For Stepper/ pulse...
byte bStepRest=kbStepRest;
byte bStepTo=kbStepTo;
int iStepDur=kiStepDur;


void setup() 
{
  initHardware();//Mostly things that happened in Sparkfun demo.
  
  connectWiFi();//I could have sworn this was "connectWiFi() on Sparkfun page, only a day or
    // 3 before 1 Jan 17. On 1 Jan 17, they have setupWiFi() here... ON THE "ESP8266
    // Thing (not Dev Board)" page! On ESP8266 Thing DEV BOARD page it is INDEED "connectWiFi".
    //and THAT, in any case, is just a call to a page within this.

    //ARGH!!!! Two hours wasted "initHardware not declared in this scope" NOT TRUE... but you
    //may, at randon?? get that when trying to compile. If you do, move setup() and loop() to
    //bottom of code
    //ARGH ends.
    
  server.begin();
  setupMDNS();

//THIS BLOCK ADDED, TKB, 1 Jan 17 for read-DS18B20 tture sensor wants...
//See a different read-DS18B20 block for source of ideas uses.

Serial.begin(9600);
delay(100);
  
Serial.println(" ");
Serial.println(" ");
Serial.print("Welcome to ");

Serial.print(sPrgm);
Serial.print(", version: ");
Serial.println(sVersID);

Serial.println("by TK Boyd");
Serial.println(" ");
Serial.println("See.... ");
Serial.println("     http://sheepdogguides.com/arduino/DS18B20-HowTo.htm");
Serial.println("for details of reading DS18B20 with ESP8266, or indeed any Arduino.");
Serial.println(" ");
delay(1500);//so human can read above.

ulMillisAtPrevTenthsBump=millis();
 
//The following was inside loop() only, in the material I drew upon
//to build this...

OneWireCheckChipAndInitVars(0);
OneWireCheckChipAndInitVars(1);

//END BLOCK ADDED BY TKB for read-DS18B20
//END BLOCK ADDED BY TKB for FW002

  //Start block of code for stepper/ pulse feature, only...
  if (boDriveStepperNotLED)
  {
     delay(200);//helps?
     MyServo.attach(ServoPin); // attaches the servo
  
     delay(400);//without this, the servo sometimes
     //"stutters" a bit before it "gets going" with
     //what loop() tells it to do. Only briefly.
     //This only tested on 3v3 so far. Stutter may
     //disappear on 5v Vss and data to servo.

     SendStepperToRest(bStepRest);//Yes- this inits hardware, but wasn't part of Sparkfun demo.

     delay(400);// to create a "gap" between setting up sstepper, and starting webpage work.
  };//end "if (boDrive..."; end of setup for stepper/ pulse


  //End of block of code only about getting ready for for stepper/ pulse feature
  //In the course of the stepper is turned to position "bStepRest".

} //end of setup()

void loop() 
{

//THIS BLOCK ADDED, TKB, 30 Dec 16 for FW002 wants...
  //LED_On_ForFWW();//Something from TKB, in tab "TKB_Bits_FWW"
  liLoopCycleCount++;
   if ((liLoopCycleCount % 60000) == 1)
   {

    //REARRANGE WHAT APPEARS WHEN....
    
    Serial.print("liLoopCycleCount= ");
    Serial.print(liLoopCycleCount);
    Serial.print("  liTenthsPassed= ");
    Serial.print(liTenthsPassed);
    Serial.print("  liPulsesAnemom= ");
    Serial.print(liPulsesAnemom);
    Serial.print("  Anemom as 4 digits= ");
    Serial.print(cAnemomThous);
    Serial.print(cAnemomHuns);
    Serial.print(cAnemomTens);
    Serial.print(cAnemomUnits);

    Serial.print("  liPulse1= ");
    Serial.print(liPulse1);
    Serial.print("  Anemom as 4 digits= ");
    Serial.print(cPulse1Thous);
    Serial.print(cPulse1Huns);
    Serial.print(cPulse1Tens);
    Serial.println(cPulse1Units);
}//end of what you do, if ((liLoopCycleCount % 60000) == 1)...
   
//THIS BLOCK ADDED, TKB, 30 Dec 16, inside block added for FW002 wants,
//for read-DS18B20 tture sensor wants...
//See a different read-DS18B20 block for source of ideas uses.

//Begin code to track tenths of seconds (or periods of a bit more) elapsed...
//This oft executed block also "watches" input from anemometer and "pulse1"

if ((liLoopCycleCount % 100)==0)
{    
     ulTmp=millis();
   if (ulTmp<ulMillisAtPrevTenthsBump)
     {ulMillisAtPrevTenthsBump=ulTmp;};
     //this handles rollover of millis.
     //this "tenth of a second" will be up
     //to 2/10th of a second long. I can live
     //with this "extra" error in 50 days!

   if (ulTmp>ulMillisAtPrevTenthsBump+100)
      { //Tenth passed
       liTenthsPassed++;
       ulMillisAtPrevTenthsBump=ulTmp;
       //I am not... yet... worring about what
       //happens when liTenthsPassed rolls over.
       //I must.. sigh... someday... maybe.
       //MAY not matter... but be SURE it doesn't.
      };

/*For debug... you probably DON'T want this block enabled, normally... the
program will probably get ahead of the bottleneck of the relatively slow
channel to the serial monitor and maybe do Weird Stuff... but it does "work"
for ten seconds, at least, at a time, if you need to check when/ what is
happening...
   Serial.print(liLoopCycleCount);
   Serial.print(" x ");
   Serial.print(ulMillisAtPrevTenthsBump);
   Serial.print(" x ");
   Serial.println(liTenthsPassed);
   */

//The oft executed block we are in also "watches" input from anemometer,
//by means of the following...
   if (digitalRead(Pin_AnemomInput)==HIGH)
   {LED_On_ForFWW();
   boIpFrmAnemomHigh=true;}
   else
   {LED_Off_ForFWW();
    boIpFrmAnemomHigh=false;};

   if (boIpFrmAnemomHigh != boIpFrmAnemomHighPrev)
     {
      boIpFrmAnemomHighPrev=boIpFrmAnemomHigh;
      liPulsesAnemom++;
     }

//The oft executed block we are in also "watches" input from "Pulse1",
//by means of the following...
//(The "anemom" pulse train counter will one day be renamed "Pulse0")
/* BLOCK *would be* REMMED OUT FOR 3-2 Curtain control
 */  
 
if (digitalRead(Pin_Pulse1Input)==HIGH)
   {LED_On_ForFWW_p1();
   boIpFrmPulse1High=true;}
   else
   {LED_Off_ForFWW_p1();
    boIpFrmPulse1High=false;};

   if (boIpFrmPulse1High != boIpFrmPulse1HighPrev)
     {
      boIpFrmPulse1HighPrev=boIpFrmPulse1High;
      liPulse1++;
     }
//END block *that would be* remmed out for 3-2 Curtain control */
};//End code to track tenths of seconds (or periods of a bit more) elapsed.

if ((liTenthsPassed%100)==5)
//pt 1 of 2, completed by if ((liTenthsPassed%100)==16)
{
  //Without next two lines, sometimes this block will
  //execute more than once when liTenthsPassed%100)==5,
  //because loop() can complete and start again before
  //liTenthsPassed has been incremented again.
  if (liTenthsPassed!=liTenthsPassedPrev)
  {
      liTenthsPassedPrev=liTenthsPassed;
      
      OneWireAskThatReadingBeStarted(0);
  }
}//end of "if ((liTenthsPassed%100)==5).."

/*TAKEN OUT from version done by elec-cafe...

    delay(1000);//CRUDE and UNSATISFACTORY "answer"

Replaced by the tenths-of-second-counter and the...
  if ((liTenthsPassed%100)==5)
  .... and....
  if ((liTenthsPassed%100)==16)
*/

if ((liTenthsPassed%100)==16)
{
//pt 2 of 2, started by if ((liTenthsPassed%100)==5)
  //Without next two lines, sometimes this block will
  //execute more than once when liTenthsPassed%100)==16,
  //because loop() can complete and start again before
  //liTenthsPassed has been incremented again.
  if (liTenthsPassed!=liTenthsPassedPrev)
    {
      liTenthsPassedPrev=liTenthsPassed;
      
     OneWireFetchReadingThatWasTaken(0);
     OneWireProcessCelsiusToOther(0);
  
     //PRINTING OF THIS IS DEFERRED UNTIL celsius0 AND celsius1 ARE AVAIL... Serial.print("Temperature0 (deg C) = ");
     //Serial.print(celsius0);
     /*
     Serial.print(" Celsius, ");
     Serial.print(fahrenheit);
     Serial.println(" Fahrenheit");
     */

  }
};//end of "if ((liTenthsPassed%100)==16)"

if ((liTenthsPassed%100)==25)
//pt 1 of 2, completed by if ((liTenthsPassed%100)==36)
{
  //Without next two lines, sometimes this block will
  //execute more than once when liTenthsPassed%100)==5,
  //because loop() can complete and start again before
  //liTenthsPassed has been incremented again.
  if (liTenthsPassed!=liTenthsPassedPrev)
  {
      liTenthsPassedPrev=liTenthsPassed;
      
      OneWireAskThatReadingBeStarted(1);
  }
}//end of "if ((liTenthsPassed%100)==25).."

if ((liTenthsPassed%100)==36)
//pt 2 of 2, started by if ((liTenthsPassed%100)==25)
{
  //Without next two lines, sometimes this block will
  //execute more than once when liTenthsPassed%100)==16,
  //because loop() can complete and start again before
  //liTenthsPassed has been incremented again.
  if (liTenthsPassed!=liTenthsPassedPrev)
    {
      liTenthsPassedPrev=liTenthsPassed;
      
     OneWireFetchReadingThatWasTaken(1);
     OneWireProcessCelsiusToOther(1);
  
     Serial.print("Temperature0 (deg C) = ");
     Serial.print(celsius0);
     Serial.print("  / Temperature1 (deg C) = ");
     Serial.print(celsius1);
     /*
     Serial.print(fahrenheit0);
     Serial.println(" Fahrenheit");
     */

    if (bInputLine==0)
     {
       Serial.println("  DigIn is LOW");
     }
     else
     {
       Serial.println("  DigIn is HIGN");
     }

     
  };;//end of if (liTenthsPassed!=liTenthsPassedPrev)
};//end of "if ((liTenthsPassed%100)==36)"

//END BLOCK ADDED BY TKB for read-DS18B20

/*
  There must be a better way!!... but, for now, this "works". Ick.
  NOW NEED TO UPDATE...
  s +=cAnemomThous;
  s +=cAnemomHunss;
  s +=cAnemomTens;
  s +=cAnemomUnits;  
  
  Now move liPulsesAnemom (a long int) to the
  four "char" variables set up to hold the
  ASCII of the four LS(digital)Ds of that
  value. (The chars are subsequently sent
  to the web-page served, so that FWW (or
  humans) can access the values.)
*/

  liTmp=liPulsesAnemom%10000;
    cAnemomThous=(liTmp /1000)+48;
  liTmp=liPulsesAnemom%1000;
    cAnemomHuns=(liTmp /100)+48;
  liTmp=liPulsesAnemom%100;
    cAnemomTens=(liTmp /10)+48;
  
  cAnemomUnits=(liTmp%10)+48;

  liTmp=liPulse1%10000;
    cPulse1Thous=(liTmp /1000)+48;
  liTmp=liPulse1%1000;
    cPulse1Huns=(liTmp /100)+48;
  liTmp=liPulse1%100;
    cPulse1Tens=(liTmp /10)+48;
  
  cPulse1Units=(liTmp%10)+48;



//END BLOCK ADDED BY TKB for FWW002
  
  // Check if a client has connected
  WiFiClient client = server.available();
  if (!client) {
    return;
  }

  // Read the first line of the request
  String req = client.readStringUntil('\r');
  Serial.println(req);
  client.flush();

  // Match the request
  int val = -1; // We'll use 'val' to keep track of both the
                // request type (read/set) and value if set.
  if (req.indexOf("/led/0") != -1)
    val = 1; // Will write LED high
  else if (req.indexOf("/led/1") != -1)
    val = 0; // Will write LED low
  else if (req.indexOf("/read") != -1)
    val = -2; // Will print pin reads

  else if (boDriveStepperNotLED)
    {if (req.indexOf("/pulse") != -1)
       val = -7;}; // Will send pulse via
       //ServoPin, using "SendStepperPulse"
       //note: val= -3,-4,-5,-6 already used, below.

 /* 
   
 ///Now for "secret" commands added by TKB, for curtain control version...
 
  else if (req.indexOf("/lightOn") != -1)
    val = -3; //

  else if (req.indexOf("/lightOff") != -1)
    val = -4; //

  else if (req.indexOf("/curtOpen") != -1)
    val = -5; //

  else if (req.indexOf("/curtClose") != -1)
    val = -6; //
    //note val=-7 already used, above.
*/
  

    
  // Otherwise request will be invalid. We'll say as much in HTML

  //===========
  //Make a note of the state of the monitored input's state
  bInputLine=digitalRead(DIGITAL_PIN);

  //============
  // Set LED_PIN according to the request
  //If using the onboard LED(+resistor) of the ESP8266, the following works...
  if (val >= 0)
    digitalWrite(LED_PIN, val);
  //If using an external LED on a different IO pin, and the LED goes 

  //Next two: For tweak put into 3-2... 
  //With Sparkfun Thing, setting D5 HIGH makes line HIGH, but LED OFF,
  //  however, the 7NC h/w controlling light on wall works the other
  //  way around... a HIGH turns fool-the-burglar light ON... i.e.
  //  the LED on D5 will be the complement of whatever the light on wall is.
  
  if (val == -3) digitalWrite(pinLight, HIGH);//Do "/lightOn" function
  if (val == -4) digitalWrite(pinLight, LOW);//Do "/lightOff" function
  
  /*Handle two commands only allowed in "curtain control" version
  ///Next block: For tweak put into 3-2... 
  //Handle /curtOpen
  if (val == -5) 
     {digitalWrite(pinCurt0, HIGH);
      digitalWrite(pinCurt1, LOW);
     };

  if (val == -6) 
     {digitalWrite(pinCurt0, LOW);
      digitalWrite(pinCurt1, HIGH);
     };
  */
  
  if (val == -7) 
   {delay(500);//Give system a moment to finish with other things
   SendStepperPulse(bStepTo, iStepDur, bStepRest);};//Should not arises unless
    //boDriveStepperNotLED is true. "Should not arise" as in
    //"code should not result in this state", not as in "steps
    //need to be taken to prevent it arising".pulse

  client.flush();

  // Prepare the response. Start with the common header:

/*
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<!DOCTYPE HTML>
<html>

*/
  
  //String s = "<!doctype html public ""-//W3C//DTD HTML 4.01 Transitional//EN"" ""http://www.w3.org/TR/html4/loose.dtd"">\r\n";
  //String s = "<html>";

  String s = "HTTP/1.1 200 OK\r\n";//DOES NOT APPEAR ON SERVED PAGE... but essential!
  s += "Content-Type: text/html\r\n\r\n";//DOES NOT APPEAR ON SERVED PAGE... but essential!
  
  //OLD   s += "<!DOCTYPE HTML>\r\n<html>\r\n";//REMEMBER: For FW003, hhhsttt.. needs to be line 8

  // Use  \"  to insert a " inside something being added to s (or a dbl "" for "s)
  
  //Line "1" of page served up... see note below about "KEEP 7 LINES"
  s += "<!doctype html public \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\r\n";
  
  //Line "2" of page...
  s += "<head>";
  s += "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\">";
  s += "<title>";
  s += sTabText;
  s += "</title>\r\n";

  //Line "3" of page...
  s += "<!--viewport added to ar794 23 Mar 19-->";
  s += "<meta name=""viewport"" content=""width=device-width, initial-scale=1.0"">\r\n";  
  
  //Line "4" of page...
  s += "</head>\r\n";
  
  //Line "5" of page...
  s += "<!--font-family for body of ar794's page set to sans-serif 23 Mar 19-->";
  s += "<body style=""font-family: Arial, Helvetica, sans-serif;"">";
  
  //THIS BLOCK ADDED, TKB, 30 Dec 16 for FW002 wants...

  //Nasty, kludgy version to allow me to skive (for now) modifying FW002.
  //This works with FW002 vers 13 Oct 16, 21:50

  s += "<h2>Yet Another Arduserver!</h2>";

  client.print(s); //Flush what's accumulated to far to webpage
  delay(1);

  s= "<p>Program: '";
  s += sPrgm;
  s += "', version: ";
  s += sVersID;
  s += "</p>";
  client.print(s); //Display program name on webpage
  delay(1);

  s = "<p>Goes back at least to late Feb 17, derived from earlier work, ";
  s += "using the wonderful ESP8266 ""Thing"" from Sparkfun,";
  s += "and the software provided by them and by others. (See code.)</p>";
  
  s += "<p>The hardware that is serving this page would cost $20 in March 2019. For details, see ";

  s += "<a href=\"http://sheepdogguides.com/elec/misc/esp8266/Esp8266-Arduserver.htm\" target=\"_blank\">";
  s += "my page with the details, including the sourcecode, for the server this comes from.</a></p>\r\n";

  //Line "6" of page...
  s += "<p>An Arduserver is a little demo of how you can set up a small web-server which will ";
  s += "allow someone with a browser to control outputs and read inputs remotely, across the internet ";
  s += "with nothing more than a browser.</p>";// \r\n removed to make hhhh... be on right line.
  
  s += "<p>Due to the following two ""odd"" lines, this Arduserver is <b><i>machine friendly</i></b>, and ";
  s += "data can be read from the Arduserver by programs running in computers elsewhere. So, for instance, ";
  s += "if you wanted an alarm to ring at location ""A"" when the temperature at location ""B"" dropped below ";
  s += "say, 40 degrees Fahrenheit, that could be arranged if you had an Arduserver at ""B"", and an ";
  s += "automatic ""Watch the Arduserver"" program running at ""A"". I call these ""FarWatchWatchers"".";
  s += "There's one that will plot the data harvested to a graph, as fetched, and record the data ";
  s += "collected to a file.</p>\r\n";

  //Line 7
  s += "<!--The next line must be the 8th line of the html generated, ";
  s += "if FarWatchWatchers (e.g. FW002 or FW003)) are to read it easily. ";
  //KEEP 7 lines... as seen by "View Page source"... above here, for the convenience of various
  //FarWatchWatchers. Many of them can have their "look at line x" x set in an ini file, but
  //lots of documentation says "try "8" first. (For these matters, the first line of the html
  //constituting the web page is "line 1" (not line "0").
  s += "  (It can have one or more extra characters at end, e.g. hhhhsttthhhhstttb)<br>-->\r\n";
  
  //Line "8" of page... and THIS (the TEXT "hhhhsttt..." MUST be HERE, for "the easy life"
  //  with old FarWatchWatchers. (New once can be configured)
  s += "hhhhsttthhhhstttb<br>\r\n";

  //and the NEXT line must come immediately after the previous, for some FarWatchWatcher needs.
  //(FW002 is a program for watching what the server is serving, and drawing graphs
  //   from the numbers.)
  //(Some only care about the following, the data line. They don't consult the "format code" line.)
  
  //The following is done horribly crudely. BAH.
  //N.B: Can't do "ab"+"cd" to get "abcd" (!)

  s +=cAnemomThous;
  s +=cAnemomHuns;
  s +=cAnemomTens;
  s +=cAnemomUnits;

  if (cSTture0=='+')
  {
   s += "+";
  } else
  {
   s += "-";    
  }
  
  s +=cTturDC0Huns;//Temperature, in Celcuis DECIdecgrees... i.e. 12.4 degC is 124 deg
  s +=cTturDC0Tens;
  s +=cTturDC0Units;

 //Next counter output... Pulse1
  s +=cPulse1Thous;
  s +=cPulse1Huns;
  s +=cPulse1Tens;
  s +=cPulse1Units;

  //tture1
  if (cSTture1=='+')
  {
   s += "+";
  } else
  {
   s += "-";    
  }
  
  s +=cTturDC1Huns;//Temperature, in Celcuis DECIdecgrees... i.e. 12.4 degC is 124 deg
  s +=cTturDC1Tens;
  s +=cTturDC1Units;

//Now add a character to show the state of the monitored input...

  if (bInputLine==0)
   {
   s +='0';
   }
   else
   {
   s +='1';
   }


  
  s +="<br>\r\n";
  s +="<br><br>\r\n";

  s +="Cycles.. yes CYCLES (repetitions of ""pulse loop()"")... ";
  s += "since Arduserver last booted: ";                   
  s += String(liLoopCycleCount);  
  s +="<br><br>\r\n";

  s += "<br><hr>\r\n";
  
  //END BLOCK ADDED BY TKB
  
  // If we're setting the LED, print out a message saying we did
  if (val >= 0)
  {
    s += "LED is now ";
    s += (val)?"off":"on";
    s += ".<br><br>\r\n";
  }
  else if (val == -2)
  { // If we're reading pins, print out those values:
    s += "Analog Pin = ";
    s += String(analogRead(ANALOG_PIN));
    s += "<br>"; // Go to the next line.
    s += "Digital Pin ";
    s += String(DIGITAL_PIN);
    s += " = ";
    s += String(bInputLine);
    s += ".<br><br>\r\n";
  }
  else 
  {//1
    if ((val != -2) && (val != -7))
    {//2
    s += "<h2>Invalid Request.</h2>\r\n";
  }//if.. 2
  }//else 1
  
  s += "You can add one of the following to the URL: The case <i>does</i> matter:<br>\r\n";
    if (boDriveStepperNotLED)
      {
        s += "/led/1, /led/0, /read or /pulse.<br>";
      }//no ; here
    else
      {
        s += "/led/1, /led/0, or /read.<br>";
      };

  if (boDriveStepperNotLED)
    {s += "boDriveStepperNotLED is set to true, enabling '/pulse' command, output on Pin_ShowAnemomInputStatus<br>";
     s += "and dis-abling the LED that could otherwise have shown state of Pin_Pulse1Input input.";
    }//no ; here
   else
    {s += "boDriveStepperNotLED is set to true, disabling '/pulse' command, driving Pin_ShowAnemomInputStatus<br>";};
     s += "and making possible an LED on that line, to show state of Pin_Pulse1Input input.";
    
  s += "<br><br><hr>"; 
  s += "<h3>Remains of part of a test to see if trying to send ";
  s += "a 'large' page would 'break' the server...</h3>\r\n";

  s += "- - - - - - - - - - - - - - - - - - - - - - - - -<br>\r\n"; 
  s += "’Twas brillig, and the slithy toves<br>\r\n"; 
  s += "&emsp;&emsp;&emsp;Did gyre and gimble in the wabe:<br>\r\n"; 
  s += "All mimsy were the borogoves,<br>\r\n"; 
  s += "&emsp;&emsp;&emsp;And the mome raths outgrabe.<br>\r\n"; 
  s += "- - - - - - - - - - - - - - - - - - - - - - - - -<br>\r\n"; 
  s += "One, two! One, two! And through and through<br>\r\n"; 
  s += "&emsp;&emsp;&emsp;The vorpal blade went snicker-snack!<br>\r\n"; 
  s += "He left it dead, and with its head<br>\r\n"; 
  s += "&emsp;&emsp;&emsp;He went galumphing back.<br>\r\n";
  s += "- - - - - - - - - - - - - - - - - - - - - - - - -<br><br><br>\r\n"; 
  
  // Send first part of the response to the client
  //2841 chars in one "go" seemed "too much".
  client.print(s); //to flush s
  delay(1);

  /*should be converted to use <p>...</p> instead of <br>s. Sigh.*/

  s = "(Many such lines DIDN'T break the Arduserver they were in (Sparkfun ESP8266 Thing Dev), 3/19.)<br><br>"; 

  s += "It seems that the web server creation "; 
  s += "is more robust (since at least Feb 17) than it was a few years ago (2013?). ";
  s += "A page as 'big' as that was would have "; 
  s += "caused arcane and tedious problems once upon a time. Hurrah "; 
  s += "for THIS kind of 'progress'!<br><br>\r\n";
   
  s += "It also seems that the 's+=' mechanism (see code) is satisfactory, "; 
  s += "and can handle a LONG string! (^_^)... but not and endless one.<br><br>\r\n";
   
  s += "----------<br>";
  s += "Beware one little 'gotcha'... I very nearly didn't catch it. When doing my test, using ";
  s += "30 lines of about 30 characters, it NEARLY "; 
  s += "passed. For a few days, I didn't catch that it was truncating a few chars from the last paragraph.<br><br>"; 
  s += "Adding the ""extra"" client.print(s) marked ""//to flush s"" fixed things.<br><br>\r\n";

  
  client.print(s); //to flush s
  delay(1);

  s = "----------<br>";
  s +="I trust you have noted this bit of 'literacy' on display ";
  s += "for you here? Us programmers are <i>not</i>, in Lee Hall's immortal";
  s += "phrase, 'A bunch of Palestines.')<br><br>\r\n";

  s += "<center>\r\n";
  s += "<h3>End of page from device explained at <a href=\"http://Arduserver.com\" target=\"_blank\">";
  s += "Arduserver.com</a><br>(Links to FarWatchWatcher explanations exist there, too.)</h3></center><br>"; 
  
  s += "</body></html>\n";

  // Send the response to the client
  client.print(s);
  delay(1);
  Serial.println("Client disonnected");

  // The client will actually be disconnected 
  // when the function returns and 'client' object is destroyed

}//of void loop()


